// ===========================================================================
// Outliner application loader
// ===========================================================================

#include <stdio.h>
#include <dlfcn.h>
#include <errno.h>
#include <unistd.h>
#include <sys/mman.h>
#include <string.h>
#include <dirent.h>
#include "outliner.h"

// ---------------------------------------------------------------------------

#include "cacheflush.c"					// cache flush function for changes made (injected code area)
#include "debug.c"					// debug functions

const char *tagfile = "/mtd_ram/.Outliner";		// tag file for already loaded checking

int delete_debug_log;					// delete debug log after successfull injection ?

// ---------------------------------------------------------------------------

// injecting procedure
// returns: 1=OK, 0=error
int injector(const char *path)
{
	char s[MAX_PATH];

	debug("injector() started");

	// open self
	unsigned *handle;
	if ( (handle = dlopen(NULL, RTLD_LAZY | RTLD_GLOBAL)) == NULL )
	{
	   debug("cannot open self:");
	   debug(dlerror());
	   return 0;
	}

	debug("self open");

	// getting exeDSP functions...
	// remote control catch functions (press & release)
	unsigned *KeyCommon_SendKeyPressInput = dlsym(handle, "_ZN9KeyCommon17SendKeyPressInputEii");
	if (KeyCommon_SendKeyPressInput == NULL ) return no_symbol(handle, "_ZN9KeyCommon17SendKeyPressInputEii");

	dlclose(handle);

	// Load main library
	sprintf(s, "%s%s", path, MAIN_MODULE);
	debug("loading main module:");
	debug(s);

	if ( (handle = dlopen(s, RTLD_NOW | RTLD_LOCAL | RTLD_NODELETE)) == NULL )
	{
	   debug("cannot open main module:");
	   debug(dlerror());
	   return 0;
	}

	// obtain injection_press procedure address
	unsigned *ex_injection_press = dlsym(handle, "injection_press");
	if (ex_injection_press == NULL) return no_symbol(handle, "injection_press");

	dlclose(handle);
	debug("main module handle closed");

	// Injecting!
 	int page = ((unsigned) KeyCommon_SendKeyPressInput) & ~0x0FFF;
	mprotect((void *) page, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
	if (KeyCommon_SendKeyPressInput[4] == 0xE51FF004)	// remapped already (by other application) ?
	{
	   debug("old injection_press detected");

	   int page2 = ((unsigned) ex_injection_press) & ~0x0FFF;
	   mprotect((void *) page2, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
	   ex_injection_press[9]  = KeyCommon_SendKeyPressInput[4];
	   ex_injection_press[10] = KeyCommon_SendKeyPressInput[5];
	   mprotect((void *) page2, 8192, PROT_READ | PROT_EXEC);
	   cacheflush(ex_injection_press+9, 8);
	}
	else debug ("first injection_press");

	// set "classic" injection_press function
	KeyCommon_SendKeyPressInput[4] = 0xE51FF004;
	KeyCommon_SendKeyPressInput[5] = (unsigned)ex_injection_press;

	mprotect((void *) page, 8192, PROT_READ | PROT_EXEC);

	cacheflush(KeyCommon_SendKeyPressInput+4, 8);

	debug("Injection complete");
	return 1;
}

// ---------------------------------------------------------------------------

// check if our module has been already loaded and attached to exeDSP process
int already_loaded()
{
   if (access(tagfile, F_OK) == 0) return 1;	// OK: tag file present => application already loaded
   return 0;					// OK: module not loaded
}

// ---------------------------------------------------------------------------

// main plugin ("Game") function
int Game_Main(const char *path, const char *udn __attribute__ ((unused)))
{
	FILE *f;

	delete_debug_log = 1;

	if (!already_loaded())
	{
	   if (injector(path))
	   {
	      if (delete_debug_log) remove(DEBUG_LOG);

	      f = fopen(tagfile, "wt"); if (f) fclose(f);
	   }
	   return 1;	// exit loader while injected module stays in memory
	}
	else
	{
	   debug("Outliner already installed");
	}

	return 1;
}

// ---------------------------------------------------------------------------

