// Outliner definitions

#define MAIN_MODULE		"outliner.so"			// main module file name

#define MAX_PATH		256				// max path size in bytes

#define SCREEN_W		(1920/2)			// OSD surface resolution: x
#define SCREEN_H		(1080/2)			// OSD surface resolution: y
#define SCREEN_BPP		32				// OSD bits-per-pixel value
#define SCREEN_FLAGS		SDL_HWSURFACE			// OSD surface flag(s)

#define BKG_COLOR		((Uint32)(0x80000000L))		// AARRGGBB color of background bar
#define BLACK_COLOR		((Uint32)(0x00000000L))		// AARRGGBB color of black

#define SRC_ADDR		(0x48291000 + 4096)		// source framebuffer address; the same problem like in ScreenCap
				// possible addresses are: 0x48291000, 0x48491000, 0x48691000, 0x48891000, 0x48a91000 or 4KB bigger

// scanning margins (not used as drawing margins)
#define MARG_UP			(SCREEN_H*2/3)			// better keep above 0
#define MARG_DOWN		20				// don't set this value too big
#define MARG_LEFT		0
#define MARG_RIGHT		0

// bar extra margins
#define MARG_HBAR		4				// bar extra lines (extra top/bottom pixels)
#define MARG_WBAR		12				// bar extra columns (width left/right pixels)

#define MAX_BARS		10				// max. number of subtitle bars (text rows)

#define CPU_WAIT		200				// [ms] - delay between thread's steps

